package org.appconn.mgmt;

import org.appconn.channel.*;

import java.net.SocketAddress;

/**
 * Class generated by <i>appconn</i> Coders.
 * Coders version: 1.2
 */
public class MgmtReplServiceClient implements MgmtReplService {

    private final SocketAddress remote;

    public MgmtReplServiceClient(SocketAddress remote) {
        this.remote = remote;
    }

    private static final TypeReader<org.appconn.mgmt.Address> ORG_APPCONN_MGMT_ADDRESS_READER = readBuffer -> TypeReader.getType(readBuffer, r -> new org.appconn.mgmt.Address(TypeReader.STRING_READER.get(r), r.getInt()));

    private static final TypeWriter<org.appconn.mgmt.Address> ORG_APPCONN_MGMT_ADDRESS_WRITER = (writeBuffer, type) -> TypeWriter.putType(writeBuffer, type, (w, t) -> {
        TypeWriter.STRING_WRITER.put(w, t.getHost());
        w.putInt(t.getPort());
    });

    private static final TypeReader<org.appconn.mgmt.Server> ORG_APPCONN_MGMT_SERVER_READER = readBuffer -> TypeReader.getType(readBuffer, r -> new org.appconn.mgmt.Server(r.getInt(), r.getInt(), TypeReader.STRING_READER.get(r), ORG_APPCONN_MGMT_ADDRESS_READER.get(r), r.get()));

    private static final TypeWriter<org.appconn.mgmt.Server> ORG_APPCONN_MGMT_SERVER_WRITER = (writeBuffer, type) -> TypeWriter.putType(writeBuffer, type, (w, t) -> {
        w.putInt(t.getId());
        w.putInt(t.getMappingKey());
        TypeWriter.STRING_WRITER.put(w, t.getName());
        ORG_APPCONN_MGMT_ADDRESS_WRITER.put(w, t.getAddress());
        w.put(t.getState());
    });

    private static final TypeReader<org.appconn.mgmt.Client> ORG_APPCONN_MGMT_CLIENT_READER = readBuffer -> TypeReader.getType(readBuffer, r -> new org.appconn.mgmt.Client(ORG_APPCONN_MGMT_ADDRESS_READER.get(r), r.get()));

    private static final TypeWriter<org.appconn.mgmt.Client> ORG_APPCONN_MGMT_CLIENT_WRITER = (writeBuffer, type) -> TypeWriter.putType(writeBuffer, type, (w, t) -> {
        ORG_APPCONN_MGMT_ADDRESS_WRITER.put(w, t.getAddress());
        w.put(t.getConnsType());
    });

    @Override
    public void addServerRepl(org.appconn.mgmt.Server arg0) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8420, client.add(ret), ret, w -> ORG_APPCONN_MGMT_SERVER_WRITER.put(w, arg0));
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void removeServerRepl(int arg0) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8421, client.add(ret), ret, w -> w.putInt(arg0));
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void publishRepl(java.lang.String arg0, int arg1) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8422, client.add(ret), ret, w -> {
                TypeWriter.STRING_WRITER.put(w, arg0);
                w.putInt(arg1);
            });
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void addClientRepl(java.lang.String arg0, org.appconn.mgmt.Client arg1) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8423, client.add(ret), ret, w -> {
                TypeWriter.STRING_WRITER.put(w, arg0);
                ORG_APPCONN_MGMT_CLIENT_WRITER.put(w, arg1);
            });
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void removeClientRepl(java.lang.String arg0, org.appconn.mgmt.Client arg1) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8424, client.add(ret), ret, w -> {
                TypeWriter.STRING_WRITER.put(w, arg0);
                ORG_APPCONN_MGMT_CLIENT_WRITER.put(w, arg1);
            });
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void setServerStateRepl(int arg0, byte arg1) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8425, client.add(ret), ret, w -> {
                w.putInt(arg0);
                w.put(arg1);
            });
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
